
-- Pure signals set by the ALU

    signal carry                            : std_logic ;
    signal overflow                         : std_logic ;
    signal negative                         : std_logic ;
    signal zero                             : std_logic ;
    signal extend                           : std_logic ;

    signal alu_carry_in                     : std_logic ;
    signal alu_carry_out_6                  : std_logic ;
    signal alu_carry_out_7                  : std_logic ;
    signal alu_carry_out_14                 : std_logic ;
    signal alu_carry_out_15                 : std_logic ;
    signal alu_carry_out_30                 : std_logic ;
    signal alu_carry_out_31                 : std_logic ;

    signal alu_int_output                   : dword_register ;
    signal alu_output                       : dword_register ;
    signal alu_ccr_output                   : word_register ;

    signal alu_output_is_minus_one          : std_logic ;


-- ALU registers
    signal ccr                              : word_register ;

    type alu_mode_type is ( ALU_NONE , ALU_I_FAMILY ,
            ALU_Q_FAMILY , ALU_NO_FAMILY , ALU_A_FAMILY ,
            ALU_X_FAMILY , ALU_ADD , ALU_ADD_UPDATE_CCRS ,
            ALU_SUBTRACT , ALU_CLR_FAMILY ) ;

    type alu_source_a_type is (
            ALU_A_PC , ALU_A_ADDRESS_X , ALU_A_PGI , ALU_A_DATA_X , 
            ALU_A_OPERAND_VALUE ) ;

    type alu_source_b_type is (
            ALU_B_PGI , ALU_B_IDR , ALU_B_DATA_Y , ALU_B_ADDRESS_Y ,
            ALU_B_OA , ALU_B_LOW_BYTE_OF_IR ) ;

    type pgi_source_type is (
            PGI_ZERO , PGI_ONE , PGI_TWO , PGI_THREE ,
            PGI_FOUR , PGI_POSTINC_PREDEC , PGI_QUICK_IMMEDIATE ) ;

