


#include "alu_optimisation.h"


/** ALU_Optimisation constructor
 *
 */
ALU_Optimisation :: ALU_Optimisation () : 
            Basic_Optimisation ( "alu_internal_op" , "alu_internal_op_type" )
{
    /* These ALU modes are always needed */
    Add_Assert ( "ALU_INT_ADD" ) ;
    Add_Assert ( "ALU_INT_SUB" ) ;
    Add_Assert ( "ALU_INT_REV_SUB" ) ;
}

/** Notify
 * 
 * This method is called with every possible opcode containing an
 * ALU operation within the program. It allows the ALU to be optimised,
 * removing unnecessary operations.
 */
void ALU_Optimisation :: Notify ( unsigned opcode , char subtype )
{
    switch ( subtype )
    {
        case '+' :
        case '-' :      /* These are always needed. */
                        break ;
        case 'c' :      Add_Assert ( "ALU_INT_CMP" ) ;
                        Add_Assert ( "ALU_INT_REV_CMP" ) ;
                        break ;
        case '^' :      Add_Assert ( "ALU_INT_EOR" ) ;
                        break ;
        case '&' :      Add_Assert ( "ALU_INT_AND" ) ;
                        break ;
        case '|' :      Add_Assert ( "ALU_INT_OR" ) ;
                        break ;
        default :       assert ( 0 ) ;
    }
}


