#ifndef BASIC_OPTIMISATION_H
#define BASIC_OPTIMISATION_H


#include <stdio.h>
#include <string.h>

#include <set>

#include "utils.h"


struct Assertion_Compare
{
    bool operator () ( const char * s1 , const char * s2 ) const
    {
        return strcmp ( s1 , s2 ) < 0 ;
    }
} ;

typedef set<const char *, Assertion_Compare> Assertion_Set ;
typedef Assertion_Set::iterator Assertion_Set_Iter ;

class Basic_Optimisation
{
public:
    Basic_Optimisation ( const char * n , const char * t ) 
        { optimisation_name = Copy_String ( n ) ; 
            optimisation_type = Copy_String ( t ) ; } ;
    virtual ~Basic_Optimisation () ;

    virtual void Notify ( unsigned opcode , char subtype ) { } ;
    virtual void Generate_VHDL ( FILE * output ) ;
    
protected:
    void Add_Assert ( const char * value ) ;

    void Add_Assert ( int value , int width ) ;

    Assertion_Set   assertion_set ;
    const char *    optimisation_name ;
    const char *    optimisation_type ;

} ;

#endif


