

#include "ea_reg_optimisation.h"

void EA_Reg_Optimisation :: Notify ( unsigned opcode , char subtype )
{
    int     ea_mode , ea_reg ;

    if ( subtype == 'e' )
    {
        /* Regular effective address, occupying bits 5 down to 0 */
        ea_mode = (( opcode >> 3 ) & 7 ) ;
        ea_reg = ( opcode & 7 ) ;
    } else if ( subtype == 'm' )
    {
        /* Move destination effective address, occupying bits 11 down to 6 */
        ea_mode = (( opcode >> 6 ) & 7 ) ;
        ea_reg = (( opcode >> 9 ) & 7 ) ;
    } else {
        /* Unknown subtype */
        assert ( 0 ) ;
    }

    if ( ea_mode == 7 )
    {
        Add_Assert ( ea_reg , 3 ) ;
    }
}


