#ifndef EXCEPTIONS_H
#define EXCEPTIONS_H

#include "ndfa_accept_state.h"



class Basic_Exception
{
public:
    Basic_Exception ( const char * msg = "" ) ;
    virtual ~Basic_Exception () ;

    virtual void PrintMessage () { } ;

protected:
    const char * msg ;
} ;


class SharedAcceptStateException : public Basic_Exception
{
public:
    SharedAcceptStateException ( Accept_State * as1 , Accept_State * as2 ) ;

    virtual void PrintMessage () ;
    
private:
    Accept_State *     as1 ;
    Accept_State *     as2 ;
} ;

class UnavailableOpcodeException : public Basic_Exception
{
public:
    UnavailableOpcodeException () 
                : Basic_Exception () {} ;
    virtual void PrintMessage () ;
} ;

class File_Access_Exception : public Basic_Exception
{
public:
    File_Access_Exception ( const char * msg ) 
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class Duplicate_Label_Exception : public Basic_Exception
{
public:
    Duplicate_Label_Exception ( const char * msg ) 
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;


class Unavailable_Microsub_Exception : public Basic_Exception
{
public:
    Unavailable_Microsub_Exception ( const char * msg ) 
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class Dir_Access_Exception : public Basic_Exception
{
public:
    Dir_Access_Exception ( const char * msg ) 
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class Unrecognised_Opcode_Map_Entry : public Basic_Exception
{
public:
    Unrecognised_Opcode_Map_Entry ( const char * msg ) 
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class No_Opcodes_Read_Exception : public Basic_Exception
{
public:
    No_Opcodes_Read_Exception ( const char * msg ) 
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class Unrecognised_Optimisation_Exception : public Basic_Exception
{
public:
    Unrecognised_Optimisation_Exception ( const char * msg ) 
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class Missing_Clock_Exception : public Basic_Exception
{
public:
    Missing_Clock_Exception ( const char * msg )
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class Empty_Machine_Exception : public Basic_Exception
{
public:
    Empty_Machine_Exception ( const char * msg )
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class No_Setting_For_Variable : public Basic_Exception
{
public:
    No_Setting_For_Variable ( const char * msg )
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;

class Unrecognised_Ini_File_Entry : public Basic_Exception
{
public:
    Unrecognised_Ini_File_Entry ( const char * msg )
                : Basic_Exception ( msg ) {} ;
    virtual void PrintMessage () ;
} ;


#endif

